/* Отдельная регулировка верха и низа


*/

#include "U8glib.h"
U8GLIB_ST7920_128X64_1X u8g(2, 3, 4, U8G_PIN_NONE);
#include <EEPROM.h>
long previousMillis = 0;
long grafMillis = 0;
long grafMillis1 = 0;
long grafMillis2 = 0;
int more=20; //темпретура термопрофиля привязанная к времени
int addr = 0; //Адрес енергонезависимой памяти
int addr1 = 1; //Адрес енергонезависимой памяти для more2
int a1 = 70; //положение минут
int a2 = 102; //положение секунд
int gr = 2000; // Время в микросекундах 100 подъем 1 град в 2 сек.
int gr1 = 1000; //шаг в сек/град. увеличени температуры до 200 
int gr2 = 500;
int I  = 0;  //Реальная температура ВЕРХ
int a = 45; //Реальная температура НИЗ
long   m  = 0;
long  m1  = 59880;
long  m2  = 0;
long s = 0;
long s1 = 0;
long Input = 0;
int more1 = 45; //Tермопрофиль   задания (Верх задание)
int more2 = 45; // Низ задание задания

void setup()
{

  //Serial.begin(9600);
  pinMode(5, INPUT_PULLUP);   // Кнопка на увелечение задания more2 низ ( номер на контролере №11)
  pinMode(6, INPUT_PULLUP);  //Кнопка на уменьшение задания  more2 низ    ( номер на контролере №12)
  pinMode(7, INPUT_PULLUP);  // Кнопка на увелечение задания  more1 верх (термопрофиль)      ( номер на контролере №13)
  pinMode(8, INPUT_PULLUP);  //   Кнопка на уменьшение задания  more1 верх (термопрофиль)  ( номер на контролере №14)
  pinMode(9, OUTPUT);  //  НИЗ №1 ( номер на контролере №15)
  pinMode(10, OUTPUT);  // НИЗ №2     ( номер на контролере №16)
  pinMode(11, OUTPUT);  // Верх  ( номер на контролере №17)


if ( u8g.getMode() == U8G_MODE_R3G3B2 ) {
    u8g.setColorIndex(255);     // white
  }
  else if ( u8g.getMode() == U8G_MODE_GRAY2BIT ) {
    u8g.setColorIndex(3);         // max intensity
  }
  else if ( u8g.getMode() == U8G_MODE_BW ) {
    u8g.setColorIndex(1);         // pixel on
  }
  else if ( u8g.getMode() == U8G_MODE_HICOLOR ) {
    u8g.setHiColorByRGB(255,255,255);
  }

}

void loop()
{
  more1 = EEPROM.read(0);
  more2 = EEPROM.read(1);
   if(more >= more1)
     {
      more = more1;
     }

  I = analogRead(1); //Реальная температура ВЕРХ
  
  I = map(I, 510, 623, 20, 200);

  a = analogRead(0); //Реальная температура НИЗ
a = map(a, 510, 623, 20, 200);
   
 
 if(a  <= more   &&   more  !=  0)  //Условие включения верхнего нагрева
     {
     
    digitalWrite(11,HIGH);
    
  }
  else
{ digitalWrite(11,LOW);
}
 


  if(more >=100) //свыше 100 до 150 градусов шаг градус в 1,5 секунд
     {
     
    gr = 1500;
    
  }
 

 if(I <= more2  &&   I  <= more  &&   more  !=  0 ) //Условие включения нижнего нагрева
     {
     
     digitalWrite(9,HIGH);
     digitalWrite(10,HIGH);
    
  }
  else
{   digitalWrite(9,LOW);
    digitalWrite(10,LOW);
}
      if (millis() -grafMillis >gr)    
     {
        grafMillis = millis();     
        more++; //темпретура термопрофиля привязанная к времени 
      }
   if(more >= 150)
     {
      gr =   10000000; //прекращаем счет
      
     }

  if (millis()  >295000)  //греем на 150 минуту и после начинаем увеличивать до 250 градусов шаг в сек/град. увеличени температуры  
     {if (millis() -grafMillis1 >gr1)    
     {
        grafMillis1 = millis();     
        more++;
       
      }
     }
if(more >= 254  )
     {
      
      gr1 =   10000000; //прекращаем счет
      
     }
  
  if (millis()  >420000    &&  Input > 254)  //Конец цикла через 7 минут если реальная температура верха превысила 254
  
  {
    more = 0;
    
  }

  s=millis()-m2;

 s=s/1000;

if( m1 < millis())
     {
      m++;
      m1=m1+60000;
      m2=m2+60000;
    
     }
          if(digitalRead(7)==LOW)//если кнопка нажата Tермопрофиль  + задания (Верх задание)
     {
          
      if (millis() -previousMillis >300)    
     {
        previousMillis = millis();     
        more1++;
         if(more1 >= 254)
     {
      more1 = 254;
     }
       EEPROM.write(addr, more1);
         }
     }

    if(digitalRead(8)==LOW)//если кнопка нажата Tермопрофиль  - задания (Верх задание)
     {
          
      if (millis() -previousMillis >300)    
     {
        previousMillis = millis();     
        more1--;
        if(more1<=45)
     {
        more1=45;
     }
     EEPROM.write(addr, more1);
     }
     }
     
      if(digitalRead(5)==LOW)//если кнопка нажата Низ + задания
     {
          
      if (millis() -previousMillis >300)    
     {
        previousMillis = millis();     
        more2++;
         if(more2 >= 201)
     {
      more2 = 201;
     }
       EEPROM.write(addr1, more2);
         }
     }

    if(digitalRead(6)==LOW)//если кнопка нажата Низ - задания
     {
          
      if (millis() -previousMillis >300)    
     {
        previousMillis = millis();     
        more2--;
        if(more2<=45)
     {
        more2=45;
     }
     EEPROM.write(addr1, more2);
     }
     }
    
    
     more2 = EEPROM.read(1); 
 
    
    if(   m  >= 0    &&  m < 10)
     {
      a1=68;
         
     } 
     
      if(   m  >= 10    &&  m < 100)
     {
      a1=62;
       
     }
      if(    m  >= 100    &&  m < 1000)
     {
      a1=54;
         
     }
     
     
           if(    s  >= 0    &&  s < 10)
     {
      a2=102;
         
     }
             if(    s  >= 10    && s < 60)
     {
      a2=95;
         
     }
     
 
     
    u8g.firstPage(); 
    do {
     u8g.setFont(u8g_font_unifont_0_8); //Русский шрифт
     u8g.drawStr( 0, 11, "Темп.верх ");
     u8g.drawStr( 0, 27, "Время");
     u8g.drawStr( 112, 27, "с. ");
     u8g.drawStr( 80, 27, "м. ");
     u8g.setPrintPos(a2, 27);
     u8g.print(s ); //время сек
     u8g.setPrintPos(a1, 27);
     u8g.print(  m ); //время мин
     u8g.drawStr( 0, 43, "Темп.низ ");
     u8g.drawStr( 0, 59, "Tермопрофиль");
     u8g.setPrintPos(100, 59); 
     u8g.print(  more);       //Tермопр.BGA
     u8g.setPrintPos(76, 11);
     u8g.print( a ); //темп верх
     u8g.setPrintPos(76, 43);
     u8g.print(I); //темп низ
      u8g.setPrintPos(103, 11); 
     u8g.print(  more1);       //Tермопр.задания 
     u8g.setPrintPos(103, 43);
     u8g.print(more2); //темп низ задание
    

     } while( u8g.nextPage() );

  }
  
